delete from report_sql where computer = {?computer};

-- num1 = id_privez
-- num2 = id_plovila
-- num3 = id_pogodbe
-- num4 = utilities rate
-- num5 = id_lastnika
-- num6 = security deposit value
-- num7 = last invoice racun_data_id
-- num8 = last invoice value
-- num9 = dolzina plovila
-- num10 = faktor za security deposit
-- str1 = elektricni prikljucek na tem privezu
-- str2 = CPM setup Y/N
-- str3 = Berth Owner Y/N
-- str4 = Sublease setup Y/N
-- str5 = Contract Y/N
-- str6 = Casual Y/N
-- str7 = billing rule time category
-- str8 = meter assigned
-- str9 = active CC Y/N
-- str10 = active DD Y/N
-- str11 = contract file uploaded Y/N
-- str12 = registration file uploaded Y/N
-- str13 = security deposit required Y/N
-- str14 = security deposit paid Y/N
-- str15 = last invoice period
-- str16 = sifra objekta
-- str17 = security deposit storitev
-- str18 = kategorija storitve str17
-- str19 = dolzinska kategorija plovila (za depozit)


-- insertiramo vse priveze s pogodbenimi kupci
insert into report_sql (computer,num1,str4,num3,str5,str6,num2)
select {?computer},p.id_privez,p.sublease,pr.id_pogodbe,'Y','N',pr.id_plovila from nnprivez p
left join nnpomol po on p.kategorija = po.sifra
left join privezi pr on p.id_privez = pr.id_privez
where pr.id_pogodbe is not null
?and po.nnlocation_id = {?location_id}
?and p.objekt = {?objekt}
;

-- insertiramo vse priveze s tranzitnimi kupci
insert into report_sql (computer,num1,str4,str5,str6,num2)
select {?computer},p.id_privez,p.sublease,'N','Y',pr.id_plovila from nnprivez p
left join nnpomol po on p.kategorija = po.sifra
left join privezi pr on p.id_privez = pr.id_privez
where pr.id_privez not in 
(select id_privez from privezi where id_pogodbe is not null)
?and po.nnlocation_id = {?location_id}
?and p.objekt = {?objekt}
;

-- insertiramo se vse ostale priveze
insert into report_sql (computer,num1,str4)
select {?computer},p.id_privez,p.sublease from nnprivez p
left join nnpomol po on p.kategorija = po.sifra
where p.id_privez not in (select num1 from report_sql where computer = {?computer})
?and po.nnlocation_id = {?location_id}
?and p.objekt = {?objekt}
;

-- za vsak privez poiscemo elektricni prikljucek
update report_sql set str1 =
(select listagg(opis,', ') within group (order by nnpriklj_id) 
from nnpriklj where id_privez = num1 and oznaka = 'EL')
where computer = {?computer};

-- CPM setup
update report_sql set str2 = 
case when num1 in 
(select id_privez from berth_owner where status = 1 and type = 1 and sysdate
between date_from and date_to) then 'Y' else 'N' end
where computer = {?computer};

-- Berth owner
update report_sql set str3 = 
case when num1 in 
(select id_privez from berth_owner where status = 1 and type = 0 and sysdate
between date_from and date_to) then 'Y' else 'N'end
where computer = {?computer};

-- billing rule time category
update report_sql set str7 =
(select listagg(k.opis,', ') within group (order by s.id_Vps) as timekat from m_vzorci_ps s left join m_nnstomar f on s.storitev = f.sifra 
left join m_nnkateg k on s.timekat = k.sifra  where f.timekat = k.sifra_sklopa and s.storno is null and s.id_pogodbe = num3)
where computer = {?computer};

-- utilities rate
update report_sql set num4 =
(select max(bruto_domaca_valuta) from m_nncenmar where storitev = 'ELEC' and nnlocation_id = {?location_id})
where computer = {?computer};

-- meter assigned
update report_sql set str8 =
(select listagg(f.opis,', ') within group (order by f.nnpriklj_id) from priklj p
left join nnpriklj f on p.id_priklj = f.nnpriklj_id where f.oznaka = 'EL' and p.id_plovila = num2)
where computer = {?computer};

-- id_lastnika
update report_sql set num5 =
(select id_lastnika from plovila where id = num2)
where computer = {?computer};

-- active CC
update report_sql set str9 =
(case when num5 in (select id_kupca from kupci_credit_cards where preferred = 'Y' and active = 'Y') then 'Y' else 'N' end)
where computer = {?computer};

-- active DD
update report_sql set str10 =
(case when num5 in (select id_lastnika from racuni_kupcev where preferred = 'Y' and direct_debit = 'Y') then 'Y' else 'N' end)
where computer = {?computer};

-- contract file uploaded Y/N
update report_sql set str11 = 
(case when num5 in (select id_kupca from datoteke_kupcev where vrsta = 'CON') then 'Y' else 'N' end)
where computer = {?computer};

-- registration file uploaded Y/N
update report_sql set str12 = 
(case when num2 in (select id from datoteke_plovil where documenttype = '10') then 'Y' else 'N' end)
where computer = {?computer};

-- last invoice racun_data_id
update report_sql set num7 =
(select id_racun_data from (select rd.id_racun_data from racun_data rd left join m_storitve s on
rd.id_storitve = s.id_storitve where s.storitev in 
(select sifra from m_nnstomar where filter in (22,25,31))
and rd.storno is null and s.id_plovila = num2
order by s.datum_od desc) where rownum = 1)
where computer = {?computer};

-- last invoice value
update report_sql set num8 =
(select max(za_placilo) from saldkont s left join racun_data rd 
on s.id_saldkont = rd.id_saldkont where rd.id_racun_data = num7)
where computer = {?computer};

-- last invoice period
update report_sql set str15 =
(select to_char(s.datum_od,'dd/mm/yyyy') || '-' || coalesce(to_char(s.datum_od,'dd/mm/yyyy'),'') from m_storitve s
left join racun_data rd on s.id_storitve = rd.id_storitve where rd.id_racun_data = num7)
where computer = {?computer};

-- security deposit required
update report_sql set str13 =
(case when str5 = 'N' then 'N' else case
when 'M' in (select v.auto_create_method from m_vzorci_ps v left join
m_pogodbe p on v.id_pogodbe = p.id_pogodbe where p.id_pogodbe = num3 and v.storno is null)
 then 'Y' else 'N' end end)
where computer = {?computer};

-- security deposit paid
update report_sql set str14 =
(case when num2 in (select id_plovila from saldkont where vrsta_racuna = 'DP')
then 'Y' else 'N' end)
where computer = {?computer};

-- sifra priveza
update report_sql set str16 =
(select objekt from nnprivez where id_privez = num1)
where computer = {?computer};

-- dolzina plovila
update report_sql set num9 =
(select dolzina from plovila where id = num2)
where computer = {?computer};

-- security deposit storitev
update report_sql set str17 =
(case when {?location_id} = 7 then 'VHMSD' 
when {?location_id} = 5 and str16 = 'DRY' then 'P35DSD'
when {?location_id} = 5 and str16 = 'SEA' then 'P35MSD'
else '' end)
where computer = {?computer};

-- faktor za security deposit
update report_sql set num10 =
(case when (str9 = 'Y' or str10 = 'Y') then 1 else 2 end)
where computer = {?computer};

-- kategorija storitve str17
update report_sql set str18 =
(select kat from m_nnstomar where sifra = str17)
where computer = {?computer}; 

-- dolzinska kategorija plovila
update report_sql set str19 =
(case when num9 is null then '-1' else (select sifra from m_nnkateg where sifra_sklopa = str18
and num9 between range_from and range_to) end)
where computer = {?computer};

-- security deposit $ value
update report_sql set num6 = 
(case when num9 is null then 0 else (select bruto_domaca_valuta from
m_nncenmar where storitev = str17 and kat = str19 and (timekat = 1 or timekat is null)) end)
where computer = {?computer};

-- pomnozimo s faktorjem
update report_Sql set num6 = num6*num10
where computer = {?computer};