delete from report_sql where computer = {?computer};

-- OPIS
-- report izpise vse pogodbe, pri katerih je bil narejen dokoncni odhod v casu po zacetku pogodbe
-- izpisemo samo vzorce, ki imajo mesecno ali letno ceno (ne vzamemo monthly daily (prorata))


-- STOLPCI

-- num1 = billing rule value (neto znesek vzorca)
-- num2 = contract value (znesek, ki bo obracunan iz vzorca = num1 x num5)
-- num3 = id_plovila
-- num4 = nnlocation_id
-- num5 = faktor, kolikokrat bo vzorec obracunan izracunan iz dolzine pogodbe in payment method
-- num6 = id vzorca (M_VZORCI_PS.ID_VPS)
-- num7 = YTD billings (vsota knjizb v obdobju pogodbe za konto, ki je definiram za vzorec)
-- num8 = id_lastnika

-- str1 = priimek (KUPCI.PRIIMEK)
-- str2 = ime (KUPCI.IME)
-- str3 = marina (NNLOCATION.OPIS)
-- str4 = objekt (NNOBJEKT.OPIS) 
-- str5 = storitev na vzorcu (M_NNSTOMAR.OPIS)
-- str6 = time kat vzorca (M_NNKATEG.OPIS)
-- str7 = pogodbeni privez (M_POGODBE.N_PRIVEZA)
-- str8 = sifra objekta (M_POGODBE.OBJEKT)
-- str9 = sifra storitve (M_VZORCI_PS.STORITEV)
-- str10 - str14 - indikatorji za d'albora owned, CPM, private rental, berth owner in sublease (uporabimo samo za filtre) 
-- str15 = departure reason (FINAL_DEPARTURE.REASON)
-- str16 = sifra storitve

-- date1 = departure date (DOGODKI.DATUM_ZACETKA)
-- date2 = datum zacetka pogodbe
-- date3 = konec pogodbe

insert into report_sql (computer,num1,num5,num3,num4,str1,str2,str3,str4,str5,str6,str7,str8,str9,date1,num6,date2,date3,num8,str16)
select {?computer},round(v.skupaj*((100-coalesce(v.popust,0))/100)*((100-coalesce(v.popust1,0))/100)*((100-coalesce(v.popust2,0))/100),2),
case 
when p.datum_konca is null and p.datum_prekinitve is null and v.datum_konca is null then 0 
when trunc(p.datum_prekinitve) < trunc(p.datum_zacetka) or  trunc(p.datum_prekinitve) < trunc(v.datum_zacetka) or trunc(v.datum_zacetka) > trunc(p.datum_konca) then 0
when v.auto_create_method = 'D' then 1 
when v.auto_create_method = 'M' then floor(months_between(least(coalesce(p.datum_prekinitve,p.datum_konca),coalesce(v.datum_konca,p.datum_prekinitve,p.datum_konca))+1,v.datum_zacetka)) 
when v.auto_create_method = 'Q' then floor(months_between(least(coalesce(p.datum_prekinitve,p.datum_konca),coalesce(v.datum_konca,p.datum_prekinitve,p.datum_konca))+1,v.datum_zacetka)/3) 
when v.auto_create_method = 'H' then floor(months_between(least(coalesce(p.datum_prekinitve,p.datum_konca),coalesce(v.datum_konca,p.datum_prekinitve,p.datum_konca))+1,v.datum_zacetka)/6) 
when v.auto_create_method = 'Y' then floor(months_between(least(coalesce(p.datum_prekinitve,p.datum_konca),coalesce(v.datum_konca,p.datum_prekinitve,p.datum_konca))+1,v.datum_zacetka)/12) 
else 1 end,
pl.id,l.id,k.priimek,k.ime,l.opis,o.opis,s.opis,kat.opis,p.n_priveza,p.objekt,v.storitev,
(select min(datum_zacetka) from dogodki where kategorija_dogodka = 'OD' and id_plovila = pl.id and trunc(datum_zacetka) >= trunc(p.datum_zacetka) and trunc(datum_zacetka) between {?datum_od} and {?datum_do}),
v.id_vps,p.datum_zacetka,coalesce(p.datum_prekinitve,p.datum_konca),p.id_lastnika,v.storitev
from m_pogodbe p 
left join m_vzorci_ps v on p.id_pogodbe = v.id_pogodbe
left join kupci k on p.id_lastnika = k.id
left join plovila pl on p.id_plovila = pl.id
left join nnlocation l on p.nnlocation_id = l.id
left join nnobjekt o on p.objekt = o.sifra
left join m_nnstomar s on v.storitev = s.sifra
left join m_nnkateg kat on s.timekat = kat.sifra_sklopa and v.timekat = kat.sifra
where v.storno is null 
and (kat.opis in ('Monthly','Prepaid','Prepaid 13th month free','Monthly 13th month free','Prepaid 3 Months','Prepaid - 6 Months',
'Prepaid - 12 Months','Monthly - Daily','3 Months - Daily','6 Month - Daily','12 Months - Daily','6 Month Prepaid') or (kat.opis is null and v.auto_create_method in ('M','Y')))
and coalesce(p.datum_prekinitve,p.datum_konca) between {?datum_od} and {?datum_do}
?and (k.vrsta = {?vrsta} or k.id in (select id_kupca from kupci_vrsta where vrsta = {?vrsta}))
;



update report_sql set 
num2 = round(num1*num5,2) 
where computer = {?computer};

update report_sql set str15 =
(select max(reason) from final_departure where id_plovila = num3 and trunc(departure_date) = trunc(date1))
where computer = {?computer} and date1 is not null;


-- indikator za CPM
update report_sql
set str10 = 'Y'
where str7 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 1 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str10 = 'N'
where str10 is null and computer = {?computer};

-- indikator za private rental
update report_sql
set str11 = 'Y'
where str7 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 2 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str11 = 'N'
where str11 is null and computer = {?computer};

-- indikator za berth owner
update report_sql
set str12 = 'Y'
where str7 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 0 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str12 = 'N'
where str12 is null and computer = {?computer};

-- indikator za sublease
update report_sql
set str13 = 'Y'
where str7 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_sublease where ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str13 = 'N'
where str13 is null and computer = {?computer};

-- indikator za dalbora owned (vse ostalo)

update report_sql
set str14 = case when str10 = 'N' and str11 = 'N' and str12 = 'N' and str13 = 'N' then 'Y' else 'N' end
where computer={?computer};

update report_sql set num7 =
(SELECT SUM(K.DZNESEK) FROM KNJIZBE K JOIN SIFKONT S ON K.KONTO = S.CTRL
LEFT JOIN TEMGRU T ON S.OZNAKA = T.KONTO_SIT LEFT JOIN NVEZASG V ON T.SIFRA = V.SIF_GRUPE 
WHERE V.SIF_STOR = STR16
AND TRUNC(K.DATUMV) BETWEEN TRUNC(DATE2) AND TRUNC(DATE3) AND PARTNER = NUM8)
where computer = {?computer};
