delete from report_sql where computer={?computer};

--dolzina (num1) in st. prostih privezov (num2)
insert into report_sql (computer, num2, date1, date2, STR1, num20)
select {?computer}, count(*), {?datum_od}, {?datum_do}, N_PRIVEZA, limit from nnprivez
where occupancy_statistics = 'Y'
?and objekt = {?objekt} 
?and kategorija = {?kategorija}
?and id_privez = {?privez}
and objekt not in ('BYNB','MB','BYAB')
group by n_priveza, limit;

-- zasedeni privezi (num3)
update report_sql set
num3=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, n_priveza from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.n_priveza
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (0,1)
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and nnprivez.objekt = {?objekt} 
             ?and nnprivez.kategorija = {?kategorija}
	     ?and r.id_privez= {?privez}
             )
            group by n_priveza)
     where n_priveza=str1),0)
where computer={?computer};

--st. dni na voljo (num4)
update report_sql set
num4=({?datum_do}-{?datum_od})+1
where computer={?computer};

--st.dni zasedenih (num5)
update report_sql set
num5=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, n_priveza from (
             select 
                 case when r.datum_od = r.datum_do then 0 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od
                     end
                 end as st_zased_dni, 
                 nnprivez.n_priveza
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
	     left join rezervac on r.id_rezervac = rezervac.id
             where r.status_rezervac in (0,1)
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and nnprivez.objekt = {?objekt} 
             ?and nnprivez.kategorija = {?kategorija}
	     ?and rezervac.vrsta = {?vrsta}
             )
            group by n_priveza)
     where n_priveza=str1),0)
where computer={?computer};

update report_sql 
set num19 = (SELECT CASE WHEN DOLZINA <= 10 OR DOLZINA IS NULL THEN 10 
WHEN DOLZINA > 10 AND DOLZINA <= 12 THEN 12
WHEN DOLZINA > 12 AND DOLZINA <= 15 THEN 15
WHEN DOLZINA > 15 AND DOLZINA <= 18 THEN 18
WHEN DOLZINA > 18 AND DOLZINA <= 23 THEN 23
WHEN DOLZINA > 23 THEN 24 END FROM NNPRIVEZ
where n_priveza=str1)
WHERE computer={?computer};



update report_sql
set num5=num5+1
where num5<>0 and computer={?computer};
-- dodamo se berth maintenance

update report_sql set
num7 = (select sum(case when m.date_to > {?datum_do} then {?datum_do} else m.date_to end
- 
case when m.date_from < {?datum_od} then {?datum_od} else m.date_from end
+
case when m.date_from = m.date_to then 0 else 1 end
)
from berth_maintenance m left join nnprivez p on m.id_privez = p.id_privez 
where ((m.date_from >={?datum_od} and m.date_to <= {?datum_do}) or (m.date_from <= {?datum_od} and m.date_to >= {?datum_do})) and p.n_priveza = str1 and status = 1)
where computer = {?computer};

update report_sql
set num5 = num5 + coalesce(num7,0) 
where computer = {?computer};

--% zasedenih dni (num6)
update report_sql set
num6=(num5/num4)*100
where computer={?computer};

-- indikator za CPM
update report_sql
set str10 = 'Y'
where str1 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 1 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str10 = 'N'
where str10 is null and computer = {?computer};

-- indikator za private rental
update report_sql
set str11 = 'Y'
where str1 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 2 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str11 = 'N'
where str11 is null and computer = {?computer};

-- indikator za berth owner
update report_sql
set str20 = 'Y'
where str1 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 0 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str20 = 'N'
where str20 is null and computer = {?computer};

-- indikator za sublease
update report_sql
set str12 = 'Y'
where str1 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_sublease where ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str12 = 'N'
where str12 is null and computer = {?computer};

-- indikator za dalbora owned (vse ostalo)

update report_sql
set str13 = case when str10 = 'N' and str11 = 'N' and str12 = 'N' and str20 = 'N'then 'Y' else 'N'end
where computer={?computer};

update report_sql
set num10 = (SELECT NNLOCATION_ID FROM NNPOMOL WHERE SIFRA = (SELECT KATEGORIJA FROM NNPRIVEZ WHERE N_PRIVEZA = STR1))
where computer={?computer};