delete from report_sql where computer={?computer};

-- str1 = indikator (storitev = S, vzorec = V)
-- str2 = customer
-- str3 = sifra storitve
-- str4 = storitev / vzorec
-- str5 = n_priveza
-- str6 = ime plovila
-- str7 = frequency
-- num1 = ID (storitve ali vzorca)
-- num2 = ID kupca
-- num3 = ID plovila
-- num4 = vrednost storitve ali vzorca
-- num5 = nnlocation_id
-- num6 = id priveza
-- num7 = vrednost brez popusta
-- num8 = znesek popusta
-- date1 = next invoice date
-- date2 = zacetek storitve/vzorca
-- date3 = konec storitve/vzorca



-- odprte storitve vrste ST ter PO

insert into report_sql (computer,num1,num2,num3,num4,str1,str3,num5,num6,date2,date3,num7) 
select {?computer},m_storitve.id_storitve,m_storitve.id_lastnika,m_storitve.id_plovila,m_storitve.znesek*((100+coalesce(m_storitve.davek,0))/100)*((100-coalesce(m_storitve.popust,0))/100)*
((100-coalesce(m_storitve.popust1,0))/100)*((100-coalesce(m_storitve.popust2,0))/100)*((100-coalesce(m_storitve.provizija,0))/100),'S',m_storitve.storitev,m_storitve.nnlocation_id,m_storitve.id_privez,m_storitve.datum_od,m_storitve.datum_do,
m_storitve.znesek*((100+coalesce(m_storitve.davek,0))/100)
from m_storitve left join m_nnstomar on m_storitve.storitev = m_nnstomar.sifra 
where m_storitve.n_racuna is null and m_storitve.vrsta in ('ST','PO') and m_nnstomar.metoda = 'Y';

-- odprti ter aktivni vzorci

insert into report_sql (computer,num1,num2,num3,num4,str1,str3,num5,num6,str7,date1,date2,date3,num7)
select {?computer}, m_vzorci_ps.id_vps,m_pogodbe.id_lastnika,m_pogodbe.id_plovila,m_vzorci_ps.skupaj*((100-coalesce(m_vzorci_ps.popust,0))/100)*
((100+coalesce(m_vzorci_ps.davek,0))/100),'V',m_vzorci_ps.storitev,m_pogodbe.nnlocation_id,m_vzorci_ps.id_privez,case m_vzorci_ps.auto_create_method when 'H' then 'Half-yearly' when 'M' then 'Monthly' when 'D' then 'Daily' when 'Y' then 'Yearly' when 'Q' then 'Quaterly' when 'C' then 'Custom' when 'F' then 'No automatic invoicing' else '' end,m_vzorci_ps.next_auto_date,m_vzorci_ps.datum_zacetka,m_vzorci_ps.datum_konca,
m_vzorci_ps.skupaj*((100+coalesce(m_vzorci_ps.davek,0))/100)
from m_vzorci_ps left join m_pogodbe on m_vzorci_ps.id_pogodbe = m_pogodbe.id_pogodbe
left join m_nnstomar on m_vzorci_ps.storitev = m_nnstomar.sifra
where m_vzorci_ps.storno is null 
and m_vzorci_ps.active = 'Y' 
and m_vzorci_ps.datum_zacetka <= {?to}
and COALESCE(m_pogodbe.DATUM_PREKINITVE,COALESCE(m_pogodbe.DATUM_KONCA,{?to}))>={?to}
and m_nnstomar.metoda = 'Y' 
and (m_vzorci_ps.datum_konca is null or (m_vzorci_ps.datum_konca >= {?from}))
and (m_pogodbe.datum_konca is null or (m_vzorci_ps.datum_zacetka <= coalesce(m_pogodbe.datum_prekinitve,m_pogodbe.datum_konca)))
and (((m_vzorci_ps.AUTO_CREATE_METHOD IS NULL OR (m_vzorci_ps.AUTO_CREATE_METHOD NOT IN ('C', 'F'))) AND (m_vzorci_ps.NEXT_AUTO_DATE IS NULL OR m_vzorci_ps.NEXT_AUTO_DATE<={?to})) OR (m_vzorci_ps.AUTO_CREATE_METHOD='C' AND m_vzorci_ps.ID_VPS IN (SELECT ID_VPS FROM M_VZORCI_INVOICE WHERE SERVICE_DATE<={?to} AND ID_STORITVE IS NULL))) AND ((m_pogodbe.STATUS IN ('O', 'A')) OR (m_pogodbe.DATUM_ZACETKA<={?to} AND COALESCE(m_pogodbe.DATUM_PREKINITVE,COALESCE(m_pogodbe.DATUM_KONCA,{?to}))>={?to}));

-- ime kupca

update report_sql 
set str2 = (select case when ime is null then priimek else ime || ' ' || priimek end from kupci where id = num2)
where computer = {?computer};


-- ime storitve 

update report_sql 
set str4 = (select opis from m_nnstomar where sifra = str3)
where computer = {?computer}; 

-- n_priveza

update report_sql
set str5 = (select n_priveza from nnprivez where id_privez = num6)
where computer = {?computer};

-- ime plovila

update report_sql
set str6 = (select ime from plovila where id = num3)
where computer = {?computer};

-- znesek popusta 

update report_sql
set str8 = num7 - num4
where computer = {?computer};

