SELECT ID_KUPCA, 
       MAX(title) AS "Title",
       MAX(ime) AS "Given Name",
       MAX(priimek) AS "Surname",
       CASE WHEN MAX(email1) IS NULL THEN MAX(email2) ELSE MAX(email1) END AS "Email1",
       CASE WHEN MAX(email1) IS NOT NULL THEN MAX(email2) ELSE NULL END AS "Email2"
FROM (       
  SELECT kupci.id AS ID_KUPCA,
       nntitle.opis AS title,
       kupci.ime AS ime,
       kupci.priimek AS priimek,
       kupci.email AS email1,
       null AS email2
  FROM   kupci
  LEFT OUTER JOIN nntitle ON (kupci.ntitle=nntitle.sifra)
  WHERE  kupci.email IS NOT NULL
  UNION ALL
  SELECT kupci.id AS ID_KUPCA,
       nntitle.opis AS title,
       kupci.ime AS ime,
       kupci.priimek AS priimek,
       null AS email1,
       kupci_correspondence.naslov AS email2
  FROM   kupci
  LEFT OUTER JOIN nntitle ON (kupci.ntitle=nntitle.sifra)
  LEFT OUTER JOIN kupci_correspondence ON (kupci.id=kupci_correspondence.id_kupca AND kupci_correspondence.vrsta_corr IN ('008', '009', '017', '020') AND kupci_correspondence.akt='Y')
  WHERE  kupci_correspondence.naslov IS NOT NULL
)
GROUP BY id_kupca
order by 4
;