delete from report_sql where computer = {?computer};

-- num1 = id_storitve
-- num2 = id_plovila
-- num3 = dolzina plovila (feet)
-- num4 = st. dni na storitve 
-- num5 = st. dni v marini
-- num6 = nnlocation_id
-- str1 = ownership
-- str5 = n_priveza

insert into report_sql (computer,num1,num2,num3,num4,num6,str1)
select {?computer}, s.id_storitve,s.id_plovila,p.dolzina * 3.28,
case when s.datum_od = s.datum_do then 0 
when s.datum_od < {?datum_od} then 
case when s.datum_do < {?datum_do} then s.datum_do - {?datum_od} + 1
else {?datum_do} - {?datum_od} + 1 
end
when s.datum_od >= {?datum_od} then
case when s.datum_do < {?datum_do} then s.datum_do - s.datum_od + 1 
else {?datum_do} - s.datum_od + 1
end
end,
s.nnlocation_id,'M'
from racun_data r left join m_storitve s on r.id_storitve = s.id_storitve
left join plovila p on s.id_plovila = p.id
left join saldkont s1 on r.id_saldkont = s1.id_saldkont
left join m_nnstomar m on s.storitev = m.sifra
left join nnprivez pr on s.id_privez = pr.id_privez
where s.n_racuna not in ('DELETE','STORNO')
and pr.objekt = {?objekt}
and (m.opis like '%Berthing%' or m.opis like '%Storage%')
and s.datum_od <= {?datum_do} and s.datum_do >= {?datum_od};

--st.dni zasedenih (num5)
update report_sql set
num5=nvl((select st_zased_dni_sum from
(select sum(st_zased_dni) as st_zased_dni_sum, id_plovila from (
select 
case when r.datum_od = r.datum_do then 0 
when r.datum_od < {?datum_od} then 
case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od} + 1
else {?datum_do} - {?datum_od} + 1 
end
when r.datum_od >= {?datum_od} then
case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od + 1 
else {?datum_do} - r.datum_od + 1
end
end as st_zased_dni, 
rezervac.id_plovila as id_plovila
from rezervac_detail r
join nnprivez on r.id_privez=nnprivez.id_privez
left join rezervac on r.id_rezervac = rezervac.id
where r.status_rezervac in (0,1)
and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
r.datum_od = r.datum_do and r.datum_od = {?datum_od}))
group by id_plovila)
where id_plovila=num2),0)
where computer={?computer};

-- n_priveza
update report_sql set str5 = 
(select p.n_priveza from m_storitve s left join nnprivez p on s.id_privez = p.id_privez where s.id_storitve = num1)
where computer = {?computer};

--ownership

update report_sql
set str2 = 'O'
where str5 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 1 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str3 = 'P'
where str5 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_owner where type = 2 and status = 1 and ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str4 = 'S'
where str5 in (select n_priveza from nnprivez where id_privez in (select id_privez from berth_sublease where ((date_from <= {?datum_od} and date_to >= {?datum_od}) or (date_from >= {?datum_od} and date_from <= {?datum_do}))))
and computer={?computer};

update report_sql
set str1 = str2
where str2 is not null
and computer={?computer};

update report_sql
set str1 = str3
where str3 is not null
and computer={?computer};

update report_sql
set str1 = str4
where str4 is not null
and computer={?computer};