delete from sql_reports where computer={?Computer}
;

insert into sql_reports (computer, n1, n2, n3, n4, s1, d1, s2, n10,n9,n8)
select {?Computer}, a.id_saldkont, abs(Nvl(a.za_placilo,0)), abs(Nvl(a.porabljeno,0)), 0, a.sdk_rn_pl, 
{?Datum}, a.vrsta_racuna, a.za_placilo, a.id_kupca,a.nnlocation_id
from saldkont a, nknjizba b where a.datum<={?Datum} 
and a.vrsta_racuna=b.saldkont and 
(b.deposit is null or (b.deposit is not null and b.deposit<>'Y'))
?and (case when a.vrsta_racuna in ('DSU','DOP','OSU') then 1 else 0 end) <> {?sublease}
;

update sql_reports
set n4=(select abs(Nvl(Sum(abs(a.znesek)),0)) from saldkont_zap a, saldkont b where a.id_pl_saldkont=b.id_saldkont 
and b.datum>{?Datum} and a.id_saldkont=n1)
where computer={?Computer}
;

update sql_reports
set n5=(select abs(Nvl(Sum(abs(a.znesek)),0)) from saldkont_zap a, saldkont b where a.id_saldkont=b.id_saldkont 
and b.datum>{?Datum} and a.id_pl_saldkont=n1)
where computer={?Computer}
;

update sql_reports
set n6=n3-(n4+n5)
where computer={?Computer}
;

-- odstejemo zapiranja z DDE transakcijami
update sql_reports set n6 = n6 - (select coalesce(sum(z.znesek),0) from saldkont_zap z left join saldkont p on z.id_pl_saldkont = p.id_saldkont 
where z.id_saldkont = n1 and p.vrsta_racuna = 'DDE')
where computer = {?computer}
;

update sql_reports
set n6=n6*(-1) where n10<0 and computer={?Computer}
;

delete from sql_reports where computer={?Computer} and Round(n10,2)=Round(n6,2)
;

delete from sql_reports where computer={?Computer}  and abs(Round(n10,2)-Round(n6,2))<1
;

-- d2 - minimalni datum storitve

update sql_reports set d2 =
(select min (datum_od) from racun_data where id_saldkont=n1)
where computer = {?computer};

-- d3 - maksimalni datum storitve

update sql_reports set d3 =
(select max (datum_od) from racun_data where id_saldkont=n1)
where computer = {?computer};

-- s3 = indikator za tenant subtype

update sql_reports set s3 = 
(case when n9 in (select id_kupca from kupci_vrsta where vrsta in ('18','6','99','HT')) then 'Y' else 'N' end)
where computer = {?computer};

-- s4 = indikator za CPM

update sql_reports set s4 =
(case when n9 in (select id_lastnika from berth_owner where status = 1 and type = 1 and 
{?Datum} between date_from and date_to) then 'Y' else 'N' end)
where computer = {?computer};

-- s5 = marina

update sql_reports set s5 = 
(select opis from nnlocation where id = n8)
where computer = {?computer};

-- s6 = objekt (plovila)

update sql_reports set s6 =
(select opis from nnobjekt where sifra = (select max(trenutni_objekt_priveza) from plovila where id_lastnika = n9))
where computer = {?computer};

-- s7 = indikator za currently contracted

update sql_reports set s7 =
(case when n9 in (select id_lastnika from m_pogodbe where {?datum} >= datum_zacetka
and ({?datum} <= coalesce(datum_prekinitve,datum_konca) or
(datum_prekinitve is null and datum_konca is null))) then 'Y' else 'N' end)
where computer = {?computer};

-- n7 = suma depozitov za lokacijo

update sql_reports set n7 =
(select sum(za_placilo)
 from saldkont 
 where vrsta_racuna in (select saldkont from nknjizba where deposit='Y')
 and datum <= {?datum}
 and id_kupca = sql_reports.n9 and nnlocation_id = sql_reports.n8)
where computer = {?computer};

-- s8 = indikator Direct Debit
update sql_reports set s8 = 
       case when (select count(*) from racuni_kupcev where id_lastnika = sql_reports.n9 and preferred = 'Y' and direct_debit = 'Y') > 0 then 'Yes' else 'No' end
where computer = {?computer};

-- s9 = indikator Credit Card
update sql_reports set s9 = 
       case when (select count(*) from kupci_credit_cards where id_kupca = sql_reports.n9 and preferred = 'Y' and active = 'Y') > 0 then 'Yes' else 'No' end
where computer = {?computer};

-- sl1 = zadnja beleka kupca
update sql_reports set sl1 = 
(select substr(b1.belezka,1,200) from kupcibelezke b1
 where b1.idkupca = sql_reports.n9
 and b1.veljavna='Y'
 and b1.type in (0, 130)
 and b1.id_kpbelezke=(SELECT max(b2.id_kpbelezke) FROM kupcibelezke b2 WHERE b2.idkupca=b1.idkupca AND b2.veljavna='Y'and b2.type in (0, 130)))
where computer = {?computer};
