create or replace FUNCTION Enquiry_summary (p_computer IN VARCHAR2, p_date_from IN DATE, p_date_to IN DATE)
  RETURN INTEGER
IS
  pragma autonomous_transaction;
BEGIN
  DECLARE
    CURSOR curCasual 
    IS 
      SELECT enquiry_term.term_date AS EnqDate,
             substr(to_char(enquiry_term.term_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_term.term_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_term ON enquiry.id_enquiry=enquiry_term.id_enquiry
      WHERE enquiry_term.enquiry_term=2
      AND enquiry_term.term_date IS NOT NULL
      AND enquiry_term.term_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_term.term_date;

    CURSOR curPermanent 
    IS 
      SELECT enquiry_term.term_date AS EnqDate,
             substr(to_char(enquiry_term.term_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_term.term_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_term ON enquiry.id_enquiry=enquiry_term.id_enquiry
      WHERE enquiry_term.enquiry_term IN (1,3)
      AND enquiry_term.term_date IS NOT NULL
      AND enquiry_term.term_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_term.term_date;

    CURSOR curFlagshipstorage 
    IS 
      SELECT enquiry_subject.subject_date AS EnqDate,
             substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 3 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_subject ON enquiry.id_enquiry=enquiry_subject.id_enquiry
      WHERE enquiry_subject.enquiry_subject=3
      AND enquiry_subject.subject_date IS NOT NULL
      AND enquiry_subject.subject_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_subject.subject_date;

    CURSOR curEclat 
    IS 
      SELECT enquiry_subject.subject_date AS EnqDate,
             substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_subject ON enquiry.id_enquiry=enquiry_subject.id_enquiry
      WHERE enquiry_subject.enquiry_subject=13
      AND enquiry_subject.subject_date IS NOT NULL
      AND enquiry_subject.subject_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_subject.subject_date;

    CURSOR curWedding 
    IS 
      SELECT enquiry_subject.subject_date AS EnqDate,
             substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_subject ON enquiry.id_enquiry=enquiry_subject.id_enquiry
      WHERE enquiry_subject.enquiry_subject=12
      AND enquiry_subject.subject_date IS NOT NULL
      AND enquiry_subject.subject_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_subject.subject_date;

    CURSOR curAccomodation 
    IS 
      SELECT enquiry_subject.subject_date AS EnqDate,
             substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 
                  WHEN enquiry_subject.enquiry_subject = 9 THEN 4 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_subject ON enquiry.id_enquiry=enquiry_subject.id_enquiry
      WHERE enquiry_subject.enquiry_subject IN (8,9)
      AND enquiry_subject.subject_date IS NOT NULL
      AND enquiry_subject.subject_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_subject.subject_date;

    CURSOR curSailingSchool 
    IS 
      SELECT enquiry_subject.subject_date AS EnqDate,
             substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),7,4) || substr(to_char(enquiry_subject.subject_date,'DD.MM.YYYY'),4,2) AS YearMonth,
             kupci.priimek AS Owner,
             kupci.id AS id_kupca,
             CASE WHEN kupci.code_referral = '10' THEN 2 Else 1 END AS Color,
             CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry=enquiry.id_enquiry) > 0 THEN 'M' ELSE null END AS Moor,
             (SELECT listagg (plovila.proizvajalec, ',') 
                WITHIN GROUP (ORDER BY plovila.proizvajalec) AS Boat
                FROM plovila join kupci on plovila.id_lastnika=kupci.id 
                WHERE plovila.id_lastnika=enquiry.id_kupca
             GROUP BY plovila.id_lastnika) AS Boat
      FROM enquiry
      LEFT OUTER JOIN kupci ON kupci.id=enquiry.id_kupca
      JOIN enquiry_subject ON enquiry.id_enquiry=enquiry_subject.id_enquiry
      WHERE enquiry_subject.enquiry_subject=1
      AND enquiry_subject.subject_date IS NOT NULL
      AND enquiry_subject.subject_date BETWEEN p_date_from AND p_date_to
      ORDER BY enquiry_subject.subject_date;

    CURSOR curCasualArrivals 
    IS 
      SELECT * from (
        SELECT dogodki.datum_zacetka AS DatDogodka,
               substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),7,4) || substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),4,2) AS YearMonth,
               kupci.priimek AS Owner,
               kupci.id AS id_kupca,
               CASE WHEN kupci.code_referral = '10' THEN 2 
                    WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=3 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 then 3
                    Else 1 
               END AS Color,
               CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 THEN 'M' ELSE null END AS Moor,
               (SELECT count(*) FROM m_pogodbe WHERE id_lastnika=dogodki.id_lastnika AND datum_zacetka <= dogodki.datum_zacetka AND datum_konca >=dogodki.datum_zacetka) AS Pog,
               plovila.proizvajalec AS Boat, plovila.id
        FROM dogodki
        LEFT OUTER JOIN plovila ON plovila.id=dogodki.id_plovila
        LEFT OUTER JOIN kupci ON kupci.id=plovila.id_lastnika
        WHERE kategorija_dogodka='SP'
        AND dogodki.datum_zacetka BETWEEN p_date_from AND p_date_to
      )
      WHERE pog = 0
      ORDER BY datdogodka;

    CURSOR curPermanentArrivals 
    IS 
      SELECT * from (
        SELECT dogodki.datum_zacetka AS DatDogodka,
               substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),7,4) || substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),4,2) AS YearMonth,
               kupci.priimek AS Owner,
               kupci.id AS id_kupca,
               CASE WHEN kupci.code_referral = '10' THEN 2 
                    WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=3 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 then 3
                    Else 1 
               END AS Color,
               CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 THEN 'M' ELSE null END AS Moor,
               (SELECT count(*) FROM m_pogodbe WHERE id_lastnika=dogodki.id_lastnika AND datum_zacetka <= dogodki.datum_zacetka AND datum_konca >=dogodki.datum_zacetka) AS Pog,
               plovila.proizvajalec AS Boat, plovila.id
        FROM dogodki
        LEFT OUTER JOIN plovila ON plovila.id=dogodki.id_plovila
        LEFT OUTER JOIN kupci ON kupci.id=plovila.id_lastnika
        WHERE kategorija_dogodka='SP'
        AND dogodki.datum_zacetka BETWEEN p_date_from AND p_date_to
      )
      WHERE pog > 0
      ORDER BY datdogodka;

    CURSOR curCasualDepartures 
    IS 
      SELECT * from (
        SELECT dogodki.datum_zacetka AS DatDogodka,
               substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),7,4) || substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),4,2) AS YearMonth,
               kupci.priimek AS Owner,
               kupci.id AS id_kupca,
               CASE WHEN kupci.code_referral = '10' THEN 2 
                    WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=3 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 then 3
                    Else 1 
               END AS Color,
               CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 THEN 'M' ELSE null END AS Moor,
               (SELECT count(*) FROM m_pogodbe WHERE id_lastnika=dogodki.id_lastnika AND datum_zacetka <= dogodki.datum_zacetka AND datum_konca >=dogodki.datum_zacetka) AS Pog,
               plovila.proizvajalec AS Boat, plovila.id
        FROM dogodki
        LEFT OUTER JOIN plovila ON plovila.id=dogodki.id_plovila
        LEFT OUTER JOIN kupci ON kupci.id=plovila.id_lastnika
        WHERE kategorija_dogodka='OD'
        AND dogodki.datum_zacetka BETWEEN p_date_from AND p_date_to
      )
      WHERE pog = 0
      ORDER BY datdogodka;

    CURSOR curPermanentDepartures 
    IS 
      SELECT * from (
        SELECT dogodki.datum_zacetka AS DatDogodka,
               substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),7,4) || substr(to_char(dogodki.datum_zacetka,'DD.MM.YYYY'),4,2) AS YearMonth,
               kupci.priimek AS Owner,
               kupci.id AS id_kupca,
               CASE WHEN kupci.code_referral = '10' THEN 2 
                    WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=3 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 then 3
                    Else 1 
               END AS Color,
               CASE WHEN (SELECT count(*) FROM enquiry_subject where enquiry_subject=5 and id_enquiry IN (SELECT id_enquiry FROM enquiry WHERE id_kupca=dogodki.id_lastnika)) > 0 THEN 'M' ELSE null END AS Moor,
               (SELECT count(*) FROM m_pogodbe WHERE id_lastnika=dogodki.id_lastnika AND datum_zacetka <= dogodki.datum_zacetka AND datum_konca >=dogodki.datum_zacetka) AS Pog,
               plovila.proizvajalec AS Boat, plovila.id
        FROM dogodki
        LEFT OUTER JOIN plovila ON plovila.id=dogodki.id_plovila
        LEFT OUTER JOIN kupci ON kupci.id=plovila.id_lastnika
        WHERE kategorija_dogodka='OD'
        AND dogodki.datum_zacetka BETWEEN p_date_from AND p_date_to
      )
      WHERE pog > 0
      ORDER BY datdogodka;

    recCasual                curCasual%Rowtype;
    recPermanent             curPermanent%Rowtype;
    recFlagshipStorage       curFlagshipStorage%Rowtype;
    recEclat                 curEclat%Rowtype;
    recWedding               curWedding%Rowtype;
    recAccomodation          curAccomodation%Rowtype;
    recSailingSchool         curSailingSchool%Rowtype;
    recCasualArrivals        curCasualArrivals%Rowtype;
    recPermanentArrivals     curPermanentArrivals%Rowtype;
    recCasualDepartures      curCasualDepartures%Rowtype;
    recPermanentDepartures   curPermanentDepartures%Rowtype;
    recReportSql             Report_sql%Rowtype;
    v_count                  NUMBER;
    v_count_M                NUMBER;
    v_count_F                NUMBER;
    v_mesec                  VARCHAR2(6);
    v_rownum                 NUMBER;
    v_kupec                  VARCHAR2(100);
  BEGIN
-----------------------------
-- CASUAL
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curCasual;
    LOOP
      FETCH curCasual INTO recCasual;
      EXIT  WHEN curCasual%NOTFOUND;
      BEGIN
        IF recCasual.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recCasual.YearMonth;
        END IF;
        v_kupec:=null;
        IF recCasual.Boat IS NULL THEN
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recCasual.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recCasual.Boat;
        END IF;
        IF recCasual.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recCasual.Owner) || ')';
        END IF;
        IF recCasual.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        INSERT INTO report_sql (computer, num20, num1, date1, str1, str2, num2)
        VALUES (p_computer, 0, v_rownum, recCasual.EnqDate, recCasual.YearMonth, v_kupec, recCasual.color);
      END;
    END LOOP;
    CLOSE curCasual;

-----------------------------
-- PERMANENT
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curPermanent;
    LOOP
      FETCH curPermanent INTO recPermanent;
      EXIT  WHEN curPermanent%NOTFOUND;
      BEGIN
        IF recPermanent.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recPermanent.YearMonth;
        END IF;
        v_kupec:=null;
        IF recPermanent.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recPermanent.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recPermanent.Boat;
        END IF;
        IF recPermanent.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recPermanent.Owner) || ')';
        END IF;
        IF recPermanent.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recPermanent.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str3, num3)
          VALUES (p_computer, 0, v_rownum, recPermanent.EnqDate, recPermanent.YearMonth, v_kupec, recPermanent.color);
        ELSE
          UPDATE report_sql
          SET str3=v_kupec, num3=recPermanent.color
          WHERE num1=v_rownum AND str1=recPermanent.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curPermanent;
-----------------------------
-- FLAGSHIP STORAGE
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curFlagshipStorage;
    LOOP
      FETCH curFlagshipStorage INTO recFlagshipStorage;
      EXIT  WHEN curFlagshipStorage%NOTFOUND;
      BEGIN
        IF recFlagshipStorage.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recFlagshipStorage.YearMonth;
        END IF;
        v_kupec:=null;
        IF recFlagshipStorage.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recFlagshipStorage.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recFlagshipStorage.Boat;
        END IF;
        IF recFlagshipStorage.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recFlagshipStorage.Owner) || ')';
        END IF;
        IF recFlagshipStorage.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recFlagshipStorage.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str4, num4)
          VALUES (p_computer, 0, v_rownum, recFlagshipStorage.EnqDate, recFlagshipStorage.YearMonth, v_kupec, recFlagshipStorage.color);
        ELSE
          UPDATE report_sql
          SET str4=v_kupec, num4=recFlagshipStorage.color
          WHERE num1=v_rownum AND str1=recFlagshipStorage.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curFlagshipStorage;
-----------------------------
-- ECLAT
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curEclat;
    LOOP
      FETCH curEclat INTO recEclat;
      EXIT  WHEN curEclat%NOTFOUND;
      BEGIN
        IF recEclat.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recEclat.YearMonth;
        END IF;
        v_kupec:=null;
        IF recEclat.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recEclat.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recEclat.Boat;
        END IF;
        IF recEclat.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recEclat.Owner) || ')';
        END IF;
        IF recEclat.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recEclat.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str5, num5)
          VALUES (p_computer, 0, v_rownum, recEclat.EnqDate, recEclat.YearMonth, v_kupec, recEclat.color);
        ELSE
          UPDATE report_sql
          SET str5=v_kupec, num5=recEclat.color
          WHERE num1=v_rownum AND str1=recEclat.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curEclat;
-----------------------------
-- WEDDING
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curWedding;
    LOOP
      FETCH curWedding INTO recWedding;
      EXIT  WHEN curWedding%NOTFOUND;
      BEGIN
        IF recWedding.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recWedding.YearMonth;
        END IF;
        v_kupec:=null;
        IF recWedding.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recWedding.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recWedding.Boat;
        END IF;
        IF recWedding.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recWedding.Owner) || ')';
        END IF;
        IF recWedding.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recWedding.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str6, num6)
          VALUES (p_computer, 0, v_rownum, recWedding.EnqDate, recWedding.YearMonth, v_kupec, recWedding.color);
        ELSE
          UPDATE report_sql
          SET str6=v_kupec, num6=recWedding.color
          WHERE num1=v_rownum AND str1=recWedding.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curWedding;
-----------------------------
-- ACCOMODATION
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curAccomodation;
    LOOP
      FETCH curAccomodation INTO recAccomodation;
      EXIT  WHEN curAccomodation%NOTFOUND;
      BEGIN
        IF recAccomodation.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recAccomodation.YearMonth;
        END IF;
        v_kupec:=null;
        IF recAccomodation.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recAccomodation.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recAccomodation.Boat;
        END IF;
        IF recAccomodation.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recAccomodation.Owner) || ')';
        END IF;
        IF recAccomodation.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recAccomodation.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str7, num7)
          VALUES (p_computer, 0, v_rownum, recAccomodation.EnqDate, recAccomodation.YearMonth, v_kupec, recAccomodation.color);
        ELSE
          UPDATE report_sql
          SET str7=v_kupec, num7=recAccomodation.color
          WHERE num1=v_rownum AND str1=recAccomodation.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curAccomodation;
-----------------------------
-- SAILING SCHOOL
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curSailingSchool;
    LOOP
      FETCH curSailingSchool INTO recSailingSchool;
      EXIT  WHEN curSailingSchool%NOTFOUND;
      BEGIN
        IF recSailingSchool.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recSailingSchool.YearMonth;
        END IF;
        v_kupec:=null;
        IF recSailingSchool.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recSailingSchool.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recSailingSchool.Boat;
        END IF;
        IF recSailingSchool.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recSailingSchool.Owner) || ')';
        END IF;
        IF recSailingSchool.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recSailingSchool.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str8, num8)
          VALUES (p_computer, 0, v_rownum, recSailingSchool.EnqDate, recSailingSchool.YearMonth, v_kupec, recSailingSchool.color);
        ELSE
          UPDATE report_sql
          SET str8=v_kupec, num8=recSailingSchool.color
          WHERE num1=v_rownum AND str1=recSailingSchool.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curSailingSchool;
-----------------------------
-- ARRIVALS CASUAL
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curCasualArrivals;
    LOOP
      FETCH curCasualArrivals INTO recCasualArrivals;
      EXIT  WHEN curCasualArrivals%NOTFOUND;
      BEGIN
        IF recCasualArrivals.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recCasualArrivals.YearMonth;
        END IF;
        v_kupec:=null;
        IF recCasualArrivals.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recCasualArrivals.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recCasualArrivals.Boat;
        END IF;
        IF recCasualArrivals.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recCasualArrivals.Owner) || ')';
        END IF;
        IF recCasualArrivals.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recCasualArrivals.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str9, num9)
          VALUES (p_computer, 0, v_rownum, recCasualArrivals.DatDogodka, recCasualArrivals.YearMonth, v_kupec, recCasualArrivals.color);
        ELSE
          UPDATE report_sql
          SET str9=v_kupec, num9=recCasualArrivals.color
          WHERE num1=v_rownum AND str1=recCasualArrivals.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curCasualArrivals;
-----------------------------
-- ARRIVALS PERMANENT
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curPermanentArrivals;
    LOOP
      FETCH curPermanentArrivals INTO recPermanentArrivals;
      EXIT  WHEN curPermanentArrivals%NOTFOUND;
      BEGIN
        IF recPermanentArrivals.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recPermanentArrivals.YearMonth;
        END IF;
        v_kupec:=null;
        IF recPermanentArrivals.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recPermanentArrivals.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recPermanentArrivals.Boat;
        END IF;
        IF recPermanentArrivals.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recPermanentArrivals.Owner) || ')';
        END IF;
        IF recPermanentArrivals.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recPermanentArrivals.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str10, num10)
          VALUES (p_computer, 0, v_rownum, recPermanentArrivals.DatDogodka, recPermanentArrivals.YearMonth, v_kupec, recPermanentArrivals.color);
        ELSE
          UPDATE report_sql
          SET str10=v_kupec, num10=recPermanentArrivals.color
          WHERE num1=v_rownum AND str1=recPermanentArrivals.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curPermanentArrivals;
-----------------------------
-- DEPARTURES CASUAL
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curCasualDepartures;
    LOOP
      FETCH curCasualDepartures INTO recCasualDepartures;
      EXIT  WHEN curCasualDepartures%NOTFOUND;
      BEGIN
        IF recCasualDepartures.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recCasualDepartures.YearMonth;
        END IF;
        v_kupec:=null;
        IF recCasualDepartures.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recCasualDepartures.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recCasualDepartures.Boat;
        END IF;
        IF recCasualDepartures.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recCasualDepartures.Owner) || ')';
        END IF;
        IF recCasualDepartures.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recCasualDepartures.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str11, num11)
          VALUES (p_computer, 0, v_rownum, recCasualDepartures.DatDogodka, recCasualDepartures.YearMonth, v_kupec, recCasualDepartures.color);
        ELSE
          UPDATE report_sql
          SET str11=v_kupec, num11=recCasualDepartures.color
          WHERE num1=v_rownum AND str1=recCasualDepartures.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curCasualDepartures;
-----------------------------
-- DEPARTURES PERMANENT
-----------------------------
    v_mesec:=null;
    v_rownum:=0;
    OPEN curPermanentDepartures;
    LOOP
      FETCH curPermanentDepartures INTO recPermanentDepartures;
      EXIT  WHEN curPermanentDepartures%NOTFOUND;
      BEGIN
        IF recPermanentDepartures.YearMonth=v_mesec THEN
          v_rownum:=v_rownum+1;
        ELSE
          v_rownum:=1;
          v_mesec:=recPermanentDepartures.YearMonth;
        END IF;
        v_kupec:=null;
        IF recPermanentDepartures.Boat IS NULL THEN 
          SELECT count(*) 
          INTO v_count
          FROM plovila
          WHERE id_lastnika=recPermanentDepartures.id_kupca;
          IF v_count = 0 THEN
            v_kupec:='NO_BOAT';
          ELSE
            v_kupec:=' ';
          END IF;
        ELSE
          v_kupec:=recPermanentDepartures.Boat;
        END IF;
        IF recPermanentDepartures.Owner IS NULL THEN 
          v_kupec:=v_kupec || ' (OWNER_UNKNOWN)';
        ELSE
          v_kupec:=v_kupec || ' (' || trim(recPermanentDepartures.Owner) || ')';
        END IF;
        IF recPermanentDepartures.Moor IS NOT NULL THEN
          v_kupec:=v_kupec || ' - M';
        END IF;
        SELECT count(*)
        INTO v_count
        FROM report_sql
        WHERE num1=v_rownum AND str1=recPermanentDepartures.YearMonth AND computer=p_computer;
        IF v_count=0 THEN
          INSERT INTO report_sql (computer, num20, num1, date1, str1, str12, num12)
          VALUES (p_computer, 0, v_rownum, recPermanentDepartures.DatDogodka, recPermanentDepartures.YearMonth, v_kupec, recPermanentDepartures.color);
        ELSE
          UPDATE report_sql
          SET str12=v_kupec, num12=recPermanentDepartures.color
          WHERE num1=v_rownum AND str1=recPermanentDepartures.YearMonth AND computer=p_computer;
        END IF;
      END;
    END LOOP;
    CLOSE curPermanentDepartures;
    COMMIT;
  END;
  RETURN 1;
END;