delete from report_sql WHERE COMPUTER={?Computer};
-- str1  = Berth
-- num7  = Berth type
-- str3  = Name
-- num1  = m
-- num2  = ft
-- str4  = Boat Type
-- str5  = Stat
-- num3  = Mthly
-- str6  = Qtrly
-- str7  = Comment
-- str8  = MarAgr
-- str9  = PayMeth
-- str10 = ExpDate
-- num4  = suma dolin privezov
-- str11 = nnprivez.objekt
-- num5  = nnprivez.sort_prikaz
-- str12 = nnprivez.kategorija
-- str13 = nnobjekt.opis
-- num6  = plovila.id
-- num8  = sum(m_vzorci_ps.amount_month)
-- num10 = plovila.boat_price
-- num13 = Mthly brez davka
-- num14 = id_privez
-- num15 = min(id_privez) za plovilo

INSERT INTO report_sql (computer, str1, num7, str3, num1, num2, str4, str5, num3, str6, str7, str8, str9,
                        str10, num4, str11, num5, str12, str13, num6, num8, num10, num13, num14, num15)
-- ZASEDENI privezi iz v_rezervac
SELECT {?Computer}, 
       nnprivez.n_priveza, 
       nvl(nnprivez.dolzina,0), 
       CASE WHEN kupci.ime IS NULL THEN kupci.priimek ELSE kupci.ime || ' ' || kupci.priimek END, 
       CASE WHEN plovila.ntip='CA' THEN null ELSE round(plovila.dolzina,0) END,
       CASE WHEN plovila.ntip='CA' THEN null ELSE round(plovila.dolzina*3.28084,0) END,
       plovila.proizvajalec,
       CASE WHEN (SELECT count(*) FROM kupci_vrsta WHERE id_kupca=kupci.id and vrsta='TE') > 0 THEN 'T'
            ELSE CASE WHEN (SELECT count(*) 
                            FROM m_pogodbe 
                            WHERE id_plovila=plovila.id AND
                            (({?Datum} between datum_zacetka and nvl(datum_konca,{?Datum}) and status in ('O','A','P')) OR
                             ({?Datum} between datum_zacetka and datum_prekinitve and status in ('R')))) > 0
                      THEN 'P' 
                      ELSE 'C' END
       END,
       (select round(sum(bruto),0) from m_storitve_income 
        where id_plovila is not null AND id_plovila=plovila.id AND id_privez is not null AND 
               nvl(id_racun_data,0) > 0 AND
               extract(month from m_storitve_income.datum) = extract(month from {?Datum}) AND
               extract(year from m_storitve_income.datum) = extract(year from {?Datum})),
       CASE WHEN (SELECT count(*) FROM datoteke_plovil WHERE id=plovila.id AND documenttype='6') > 0 THEN 'CCA' 
            WHEN plovila.payment_type='FOC' THEN 'FOC'
            WHEN (select count(*) from m_vzorci_ps where auto_create_method='Q' 
                  AND nvl(storno,'N') <> 'D'
                  AND storitev IN (SELECT sifra FROM m_nnstomar WHERE nvl(contract_price,'N') = 'Y')
                  and id_pogodbe in (select id_pogodbe from m_pogodbe where id_plovila=plovila.id and status in ('O','A'))) > 0 
                 THEN (SELECT to_char(round(nvl(sum(3*m_vzorci_ps.amount_month),0),0),'$99,999') FROM m_vzorci_ps WHERE nvl(storno,'N') <> 'D' 
        AND datum_zacetka <= to_date('01'||substr({?Datum},3,7),'dd.mm.yy')
        AND nvl(datum_konca,{?Datum}) >= to_date('01'||substr({?Datum},3,7),'dd.mm.yy') 
        AND id_pogodbe IN (SELECT id_pogodbe FROM m_pogodbe WHERE id_plovila=plovila.id)
        AND storitev IN (SELECT sifra FROM m_nnstomar WHERE nvl(contract_price,'N') = 'Y'))
       END,
       (SELECT substr(belezka,1,100) FROM plovilabelezke WHERE idplovila=plovila.id AND id_plbelezke = (SELECT max(id_plbelezke) FROM plovilabelezke WHERE idplovila=plovila.id AND veljavna='Y')),
       CASE WHEN (SELECT count(*) FROM datoteke_plovil WHERE id=plovila.id AND documenttype='4') > 0 THEN 'Yes' 
            ELSE CASE WHEN plovila.pogodbeni_objekt_priveza IS NOT NULL THEN 'No' ELSE 'N/A' END
       END,
       platni_instrumenti.opis,
       CASE WHEN plovila.payment_type='KAR' then (SELECT card_expire FROM kupci_credit_cards WHERE id_kupca=kupci.id AND id_kupci_cc = plovila.kupci_credit_card_id)
                                            else null
       END,
       (SELECT sum(dolzina) FROM nnprivez n1 where n1.objekt=nnprivez.objekt),
       nnprivez.objekt, 
       nnprivez.sort_prikaz, 
       nnprivez.kategorija,
       nnobjekt.opis,
       plovila.id,
       (SELECT round(nvl(sum(m_vzorci_ps.amount_month),0),0) FROM m_vzorci_ps WHERE nvl(storno,'N') <> 'D' 
        AND datum_zacetka <= to_date('01'||substr({?Datum},3,7),'dd.mm.yy')
        AND nvl(datum_konca,{?Datum}) >= to_date('01'||substr({?Datum},3,7),'dd.mm.yy') 
        AND id_pogodbe IN (SELECT id_pogodbe FROM m_pogodbe WHERE id_plovila=plovila.id)
        AND storitev IN (SELECT sifra FROM m_nnstomar WHERE nvl(contract_price,'N') = 'Y')),
       nvl(plovila.boat_price,0),
       (select round(sum(znesek),0) from m_storitve_income 
        where id_plovila is not null AND id_plovila=plovila.id AND id_privez is not null AND
               nvl(id_racun_data,0) > 0 AND
               extract(month from m_storitve_income.datum) = extract(month from {?Datum}) AND
               extract(year from m_storitve_income.datum) = extract(year from {?Datum})),
       nnprivez.id_privez,
       (select max(a.id_privez) from privezi_zasedenost a 
               join nnprivez b on a.id_privez=b.id_privez
        where a.id_plovila is not null and a.id_plovila=plovila.id and a.datum=privezi_zasedenost.datum 
        and b.sort_prikaz = (select min(sort_prikaz) from nnprivez where id_privez in 
            (select c.id_privez from privezi_zasedenost c where c.id_plovila is not null and c.id_plovila=plovila.id 
             and c.datum=privezi_zasedenost.datum))
        group by a.id_privez)
FROM privezi_zasedenost
JOIN plovila ON (privezi_zasedenost.id_plovila=plovila.id)
JOIN nnprivez ON (privezi_zasedenost.id_privez = nnprivez.id_privez)
JOIN nnobjekt ON (nnprivez.objekt=nnobjekt.sifra)
LEFT OUTER JOIN kupci ON (plovila.id_lastnika=kupci.id)
LEFT OUTER JOIN platni_instrumenti ON (plovila.payment_type=platni_instrumenti.platni_instrument)
WHERE privezi_zasedenost.datum = {?Datum}
AND privezi_zasedenost.id_plovila IS NOT NULL
;
