delete from report_sql
where computer={?COMPUTER};

--members
insert into report_sql 
      (computer   , str1   , str2, str3     , date1        , str13,             num3   , num4    , num5, num6, str4, str14 , str5  , num1, str6   , date2     , str7, str8     , num7       , str12) 
select {?COMPUTER}, priimek, ime , id_member, datum_rojstva, email, age_yrs, age_mths, min , max , type, sftype, status, id  , card_id, card_issue, tip , 'MEMBERS', nvl({?AddMonths},0), {?OnlyOverUnder} from 
--overaged
(select k.priimek, k.ime, k.id_member, k.datum_rojstva, k.email, trunc(months_between(sysdate, k.datum_rojstva)/12) as age_yrs,
       trunc(months_between(sysdate, k.datum_rojstva))-trunc(months_between(sysdate, k.datum_rojstva)/12)*12 as age_mths,
        na1.nvrednost as min, na.nvrednost as max, n.opis as type, n.sifra as sftype, st.opis as status, k.id, k.yacht_club_id as card_id, k.card_issue, 'OVERAGED' as tip
from kupci k
join application_form app on k.id_app_form = app.id
join nnvrskup n on n.sifra=app.member_type
join nnvrskup_atributi na on  n.sifra=na.sifra_vrskup and na.sifra_atribut='AGX'
left outer join nnvrskup_atributi na1 on  n.sifra=na1.sifra_vrskup and na1.sifra_atribut='AGM'join nnmembstatus st on app.status=st.sifra and st.sifra in ('02', '06', '26', '11', '12', '36', '46', '07')
where trunc(months_between(sysdate, k.datum_rojstva)/12)>=na.nvrednost
union
--overaged in next X months
select k.priimek, k.ime, k.id_member, k.datum_rojstva, k.email, trunc(months_between(sysdate, k.datum_rojstva)/12) as age_yrs, 
       trunc(months_between(sysdate, k.datum_rojstva))-trunc(months_between(sysdate, k.datum_rojstva)/12)*12 as age_mths,
       na1.nvrednost as min, na.nvrednost as max, n.opis as type, n.sifra as sftype, st.opis as status, k.id, k.yacht_club_id as card_id, k.card_issue, 'OVER_XM' as tip
from kupci k
join application_form app on k.id_app_form = app.id
join nnvrskup n on n.sifra=app.member_type
join nnvrskup_atributi na on  n.sifra=na.sifra_vrskup and na.sifra_atribut='AGX'
left outer join nnvrskup_atributi na1 on  n.sifra=na1.sifra_vrskup and na1.sifra_atribut='AGM'
join nnmembstatus st on app.status=st.sifra and st.sifra in ('02', '06', '26', '11', '12', '36', '46', '07')
where (trunc(months_between(sysdate, k.datum_rojstva)+nvl({?AddMonths},0))/12)>=na.nvrednost
and (trunc(months_between(sysdate, k.datum_rojstva))/12)<na.nvrednost
)
;


--dependants
insert into report_sql 
      (computer   , num1 , num2, str1     , str2 ,   str13,     str3       , str9      , str10 , str6             , date2        , date1           , 
       num3, 
       num4, 
       str11             , str8, num7) 
select {?COMPUTER}, k1.id, k.id, k1.priimek, k1.ime, k.email, k.id_member, k.priimek, k.ime, k1. yacht_club_id, k1.card_issue, k1.datum_rojstva, 
       trunc(months_between(sysdate, k1.datum_rojstva)/12) as age_yrs,
       trunc(months_between(sysdate, k1.datum_rojstva))-trunc(months_between(sysdate, k1.datum_rojstva)/12)*12 as age_mths,
       l.can_sign_invoice, 'DEPENDANTS', {?AddMonths}
from kupci k
join application_form app on k.id_app_form = app.id
join kont_osb_lastnik l on l.id_lastnika=k.id and l.depandent='Y' and l.odnos='C'
join kupci k1 on l.id_osebe=k1.id
left outer join nnvrskup n on n.sifra=app.member_type
join nnmembstatus st on app.status=st.sifra  and st.sifra in ('02', '07')
where (trunc(months_between(sysdate, k1.datum_rojstva)+nvl({?AddMonths},0))/12)>=18
and (l.velja_do is null or l.velja_do>=sysdate)
and {?ShowDependants}='Y'
;

update report_sql set 
str7='OVERAGED'
where computer={?COMPUTER}
and str8='DEPENDANTS'
and num3>='18'
;

update report_sql set 
str7='OVER_XM'
where computer={?COMPUTER}
and str8='DEPENDANTS'
and num3<'18'
;