delete from report_sql where computer = {?computer};

-- num1 = id saldkont
-- num2 = batch id
-- date1 = saldkont.datum
-- str1 = indikator - P pending, A potrjene
-- str2 = racun, ki ga zapira direct debit transakcija

-- vstavimo vse pending transakcije

insert into report_sql (computer, num1, date1, str1, num2)
select {?computer}, s.id_saldkont, s.datum, 'P', s1.id_batch from saldkont s
left join saldkont_zap z on s.id_saldkont = z.id_pl_saldkont
left join saldkont s1 on z.id_saldkont = s1.id_saldkont
where s.sdk_rn_pl = 'P' and s.storno is null 
and s1.id_batch is not null and s.vrsta_racuna = 'DDE';

-- vstavimo vse approved ali declined transakcije

insert into report_sql (computer, num1, date1, str1, num2)
select {?computer}, s1.id_saldkont, s1.datum, 'A', s2.id_batch from saldkont s
left join saldkont s1 on s.id_saldkont_gen = s1.id_saldkont
left join saldkont s2 on s1.id_saldkont_gen = s2.id_saldkont
where s.vrsta_racuna = 'VIR' and s1.vrsta_racuna = 'DDE'
and s1.storno is null and s2.id_batch is not null;

-- racun za pending transakcije

update report_sql set str2 =
(select s1.n_racuna from saldkont s 
left join saldkont_zap z on s.id_saldkont = z.id_pl_saldkont
left join saldkont s1 on z.id_saldkont = s1.id_saldkont where s.id_Saldkont = num1)
where computer = {?computer} and str1 = 'P';

-- racun za potrjene transakcije

update report_sql set str2 =
(select s1.n_racuna from saldkont s
left join saldkont s1 on s.id_saldkont_gen = s1.id_saldkont
where s.id_Saldkont = num1)
where computer = {?computer} and str1 = 'A';

