SELECT
  a.id_member AS "Membership No.",
  CASE WHEN a.ime IS NULL THEN a.priimek ELSE a.priimek || ', ' || a.ime END AS "Member Name",
  c.interni_opis AS " Membership Type",
  g.interni_opis AS "Status",
  f.date_approve_reject AS "Join Date",
  extract(year from f.date_approve_reject) AS "Join Date Year",
  extract(month from f.date_approve_reject) AS "Join Date Month",
  extract(day from f.date_approve_reject) AS "Join Date Day",
  a.datum_rojstva AS "Date of Birth",
  TRUNC(MONTHS_BETWEEN(SYSDATE, a.DATUM_ROJSTVA)/12) AS "Age",
  i.nvrednost AS "Max. age",
  TRUNC(ADD_MONTHS(a.DATUM_ROJSTVA,i.nvrednost*12)) AS "Expiry Date",
  CASE WHEN e.business_address_pref IS NOT NULL THEN e.business_address_pref
       WHEN e.overseas_address_pref IS NOT NULL THEN e.overseas_address_pref
       ELSE
       CASE WHEN a.mesto IS NULL AND a.posta IS NULL THEN a.naslov
            WHEN a.mesto IS NULL AND a.posta IS NOT NULL THEN a.naslov || ' ' || a.posta
            WHEN a.mesto IS NOT NULL AND a.posta IS NULL THEN a.naslov || ' ' || a.mesto
       END
  END AS "Mailing Address",
  CASE WHEN e.home_telephone_pref IS NOT NULL THEN e.home_telephone_pref
       WHEN e.company_telephone_pref IS NOT NULL THEN e.company_telephone_pref
       WHEN e.overseas_telephone_pref IS NOT NULL THEN e.overseas_telephone_pref
       ELSE a.telefon_1
  END AS "Contact Phone No.",
  a.email AS "Email Address",
  a.gsm AS "Mobile No.",
  a.use_autopay AS "Use autopay?",
  j.st_racuna AS "Account number",
  j.opis AS "Account name",
  j.banka AS "Bank",
  a.acs_limit AS "Long term parking",
  d.oznaka AS " Nationality",
  e.company_name AS "Company",
  a.occupation AS "Position",
  e.business_address AS "Company Address",
  e.company_email AS "Company Email",
  e.company_telephone AS "Office Number",
  CASE WHEN a.mesto IS NULL AND a.posta IS NULL THEN a.naslov
       WHEN a.mesto IS NULL AND a.posta IS NOT NULL THEN a.naslov || ' ' || a.posta
       WHEN a.mesto IS NOT NULL AND a.posta IS NULL THEN a.naslov || ' ' || a.mesto
  END AS "Home Address",
  e.overseas_address AS "Overseas Address"
FROM kupci a
LEFT OUTER JOIN kupci_vrsta b ON (a.id=b.id_kupca)
LEFT OUTER JOIN nnvrskup c ON (b.vrsta=c.sifra AND c.vrsta='YC')
LEFT OUTER JOIN nndrzave d ON (a.citizenship=d.sifra)
LEFT OUTER JOIN v_naslovi e ON (a.id=e.id_kupca)
LEFT OUTER JOIN application_form f ON (a.id_app_form=f.id)
LEFT OUTER JOIN nnmembstatus g ON (f.status=g.sifra)
JOIN application_form h ON (a.id_app_form=h.id)
LEFT OUTER JOIN nnvrskup_atributi i ON (c.sifra = i.sifra_vrskup and i.sifra_atribut='AGX')
LEFT OUTER JOIN racuni_kupcev j ON (j.id_lastnika=a.id)
ORDER BY a.id_member
;