SELECT 
  k.id_member AS "Membership No.",
  CASE WHEN k.ime IS NULL THEN k.priimek ELSE k.priimek || ', ' || k.ime END AS "Member Name",
  c.interni_opis AS " Membership Type",
  g.interni_opis AS "Status",
  a.date_approve_reject AS "Join date",
  k.datum_kreiranja AS "Created",
  k.user_kreiranja AS "Created by",
  p.tip_pogodbe AS "Membership Contract",
  to_char(p.datum_zacetka,'dd/mm/yyyy') AS "Contract From",
  p.komentar AS "Contract Comment",
  m.interni_opis AS "Service",
  vz.skupaj AS "Service Amount",
  CASE WHEN vz.auto_create_method = 'D' THEN 'Default'
       WHEN vz.auto_create_method = 'M' THEN 'Monthly'
       WHEN vz.auto_create_method = 'Q' THEN 'Quaterly'
       WHEN vz.auto_create_method = 'H' THEN '6-Monthly'
       WHEN vz.auto_create_method = 'Y' THEN 'Yearly'
       WHEN vz.auto_create_method = 'C' THEN 'Custom'
  END AS "Payment Method",
  vz.datum_zacetka AS "Service From",
  CASE WHEN vz.auto_create_method in ('D') THEN null ELSE vz.next_auto_date END AS "Next Charge"
FROM   v_yc_members v
JOIN   kupci k ON (v.id_kupca=k.id)
JOIN   application_form a ON (k.id_app_form=a.id)
LEFT OUTER JOIN m_pogodbe p ON (k.id=p.id_lastnika and p.id_plovila is null and p.status in ('O','A') and p.objekt is null and p.n_priveza is null)
LEFT OUTER JOIN m_vzorci_ps vz ON (p.id_pogodbe=vz.id_pogodbe and vz.storitev not in (select sifra from m_nnstomar where ngrupa='REN'))
LEFT OUTER JOIN kupci_vrsta b ON (k.id=b.id_kupca)
LEFT OUTER JOIN nnvrskup c ON (b.vrsta=c.sifra AND c.vrsta='YC')
LEFT OUTER JOIN nnmembstatus g ON (a.status=g.sifra)
LEFT OUTER JOIN m_nnstomar m ON (m.sifra=vz.storitev)
WHERE  a.date_approve_reject BETWEEN to_date({?Join date from|DATE},'dd.mm.yyyy') 
AND to_date({?Join date to|DATE},'dd.mm.yyyy')
ORDER BY k.id_member,vz.storitev
;
