SELECT migracija_kljuci.message_type AS "Type",
       migracija_kljuci.message AS "Message",
       'tblCUSTDETAILS' AS "Source table",
       mig_customers.lstname AS "Surname",
       mig_customers.frstname AS "Given name",
       mig_customers.PERSTADDLINE1 || ' ' || mig_customers.PERSTADDLINE2 AS "Address",
       mig_customers.persuburb AS "City",
       mig_customers.perpostcode AS "Postal code",
       mig_customers.custidno AS "CUSTID",
       null AS "Content"
FROM   migracija_kljuci
JOIN   mig_customers ON migracija_kljuci.hhyc_kljuc = mig_customers.CustIdNo
WHERE  hhyc_tabela='MIG_CUSTOMERS'
AND    message is not null
UNION
SELECT migracija_kljuci.message_type AS "Type",
       migracija_kljuci.message AS "Message",
       'tblENQCOMMENTS' AS "Source table",
       mig_customers.lstname AS "Surname",
       mig_customers.frstname AS "Given name",
       mig_customers.PERSTADDLINE1 || ' ' || mig_customers.PERSTADDLINE2 AS "Address",
       mig_customers.persuburb AS "City",
       mig_customers.perpostcode AS "Postal code",
       mig_enq_comments.CUSTENQID AS "CUSTID",
       mig_enq_comments.ENQCOMMENTS AS "Content"
FROM   migracija_kljuci
JOIN   mig_enq_comments ON migracija_kljuci.hhyc_kljuc=mig_enq_comments.ENQCOMMENTSID
LEFT OUTER JOIN  mig_customers ON mig_enq_comments.CUSTENQID = mig_customers.CUSTIDNO
WHERE  hhyc_tabela='MIG_CUST_COMMENTS'
AND    message is not null
UNION
SELECT migracija_kljuci.message_type AS "Type",
       migracija_kljuci.message AS "Message",
       'tblBOATDETAILS' AS "Source table",
       mig_customers.lstname AS "Surname",
       mig_customers.frstname AS "Given name",
       mig_customers.PERSTADDLINE1 || ' ' || mig_customers.PERSTADDLINE2 AS "Address",
       mig_customers.persuburb AS "City",
       mig_customers.perpostcode AS "Postal code",
       mig_boats.CUSTIDNO AS "CUSTID",
       'Card type and no. ' || mig_boats_dod1.CardType || ' ' || mig_boats_dod1.CreditCdNo || ' ExpDate: ' || mig_boats_dod1.ExpDate || ' Owner: ' || mig_boats_dod1.NameonCard AS "Content"
FROM   migracija_kljuci
JOIN   mig_boats ON migracija_kljuci.hhyc_kljuc=mig_boats.custidno
JOIN   mig_boats_dod1 ON mig_boats.boatid=mig_boats_dod1.boatid
LEFT OUTER JOIN  mig_customers ON mig_boats.CUSTIDNO = mig_customers.CUSTIDNO
WHERE  hhyc_tabela='MIG_CUST_CARDS'
AND    message is not null
UNION
SELECT migracija_kljuci.message_type AS "Type",
       migracija_kljuci.message AS "Message",
       'tblBOATDETAILS' AS "Source table",
       mig_customers.lstname AS "Surname",
       mig_customers.frstname AS "Given name",
       mig_customers.PERSTADDLINE1 || ' ' || mig_customers.PERSTADDLINE2 AS "Address",
       mig_customers.persuburb AS "City",
       mig_customers.perpostcode AS "Postal code",
       mig_boats.CUSTIDNO AS "CUSTID",
       'Boat Name: ' || mig_boats.BoatName || '; Type: ' || mig_boats.BoatType AS "Content"
FROM   migracija_kljuci
JOIN   mig_boats ON migracija_kljuci.hhyc_kljuc=mig_boats.boatid
LEFT OUTER JOIN  mig_customers ON mig_boats.CUSTIDNO = mig_customers.CUSTIDNO
WHERE  hhyc_tabela='MIG_BOATS'
AND    message is not null
ORDER BY 1 desc, 3 asc, 9 asc
;