select 
a.id AS "HHYC ID",
a.name AS "HHYC Boat Name",
a.insurance_expire AS "HHYC Insurance Expire",
a.licence_expire AS "HHYC Licence Expire",
mb.hhyc_registration_id AS "HHYC Registration ID",
a.remarks AS "HHYC Remarks",
c.code || ' ' || c.name AS "HHYC Boat Owner",
a.has_contract AS "HHYC Has Contract",
g.item_name AS "HHYC Rental Item",
f.start_date AS "HHYC Rental from", 
h.code || ' ' || h.name AS "HHYC Renter",
CASE WHEN j.boat_no IS NOT NULL THEN 'Mooring/Pontoon ' || j.mooring
     WHEN i.boat_no IS NOT NULL THEN 'Hardstanding ' || i.type || '-' || i.num || '-' || i.code
     WHEN k.registration_no IS NOT NULL THEN 'BW Dingy Area ' || k.label_issue_no
END AS "HHYC Position from List",
b.id AS "MM ID",
b.ime AS "MM Boat Name",
b.datum_zavarovanje AS "MM Insurance Expire",
b.dat_plov_dov AS "MM Licence Expire",
b.registrska_n AS "MM Registration ID",
CASE WHEN d.ime IS NULL THEN d.id_member || ' ' || d.priimek ELSE d.id_member || ' ' || d.priimek || ', ' || d.ime END AS "MM Boat Owner",
CASE WHEN b.n_pogodbe IS NULL THEN 0 ELSE 1 END AS "MM Has Contract",
lp.opis || ' ' || b.pogodbena_n_priveza AS "MM Rental Item",
lt.opis || ' ' || b.trenutna_n_priveza AS "MM Position in Marina"
from mig_boats a
join mig_boats_revised mb on (a.id=mb.hhyc_id)
left outer join plovila b on (mb.hhyc_registration_id=b.registrska_n)
left outer join mig_members c on (a.owner=c.id)
left outer join kupci d on (b.id_lastnika=d.id)-- and c.code=d.id_member)
left outer join nntip e on (b.ntip=e.sifra)
left outer join mig_rentals f on (a.id=f.boat and f.ceased is null)
left outer join mig_rental_items g on (f.rental_item=g.id)
left outer join mig_members h on (f.renter=h.id)
left outer join mig_boats_hardstand i on (a.registration_id=i.boat_no)
left outer join mig_boats_mooring j on (a.registration_id=j.boat_no)
left outer join mig_boats_dinghy k on (a.registration_id=k.registration_no)
left outer join nnobjekt lp on (b.pogodbeni_objekt_priveza=lp.sifra)
left outer join nnobjekt lt on (b.trenutni_objekt_priveza=lt.sifra)
order by mb.hhyc_registration_id,a.id
;