SELECT a.id_member AS "Member", 
       CASE WHEN a.ime IS NULL THEN a.priimek ELSE a.priimek || ', ' || a.ime END AS "Member Name",
       a.email AS "Email",
       h.interni_opis AS "Type",
       b.n_priveza AS "Mooring",
       d.interni_opis AS "Charge Code",
       g.interni_opis AS "Category",
       c.skupaj AS "Monthly amount",
       e.registrska_n AS "Boat No",
       e.ime AS "Boat Name",
       e.dolzina AS "Length",
       e.grez AS "Draught",
       f.interni_opis AS "Boat Type",
       c.datum_zacetka AS "Started",
       e.datum_plovnega_dovoljenja AS "Licence",
       e.zavarovano_do AS "Expire Insurance",
       e.zavarovalnica AS "Expire Insurer"
FROM   kupci a
LEFT OUTER JOIN m_pogodbe b ON (a.id=b.id_lastnika)
LEFT OUTER JOIN m_vzorci_ps c ON (c.id_pogodbe=b.id_pogodbe)
LEFT OUTER JOIN m_nnstomar d ON (c.storitev=d.sifra)
LEFT OUTER JOIN plovila e ON (b.id_plovila=e.id)
LEFT OUTER JOIN nntip f ON (e.ntip=f.sifra)
LEFT OUTER JOIN m_nnkateg g ON (g.sifra_sklopa=d.kat AND g.sifra=c.kat)
LEFT OUTER JOIN nnobjekt h ON (b.objekt=h.sifra)
WHERE  b.status in ('O', 'A')
AND    d.ngrupa='REN'
AND    c.auto_create_method='M'
ORDER BY a.id_member
;
